#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <queue>
using namespace std;
int mx;
bool good(vector<vector<char>> places, int a, int b)
{
	for(int i = 0;i<places[0].size();i++)
	{
		if(places[a][i] == places[b][i])
			return false;
	}
	return true;
}
int main()
{
    int n,k;
	cin>>n>>k;
	if(k==1)
	{
		vector< pair<int,int> > params = vector< pair<int,int> >(n);
		int t;
		for(int i = 0;i<n;i++)
		{
			cin>>t;
			params[i].first = t;
			params[i].second = i+1;
		}
		sort(params.begin(), params.end());
		cout<<"YES\n";
		for(int i = 0;i<=n/2-1;i++)
		{
			cout<< params[i].second<<" "<<params[n-1-i].second<<endl;
		}
	}
	else
	{
		vector<vector<char>> places = vector<vector<char>>(n,vector<char>(k));
		vector< pair<int,int> > params = vector< pair<int,int> >(n);
		vector<vector<int>> arts = vector<vector<int>>(n);
		int t;
		for(int i = 0;i<n;i++)
		{
			for(int j = 0;j<k;j++)
			{
				cin>>t;
				arts[i].push_back(t);
			}
		}
		for(int j = 0;j<k;j++)
		{
			for(int i = 0;i<n;i++)
			{
				params[i].first = arts[i][j];
				params[i].second = i;
			}
			sort(params.begin(), params.end());
			for(int i = 0;i<n;i++)
			{
				if(i<n/2)
					places[params[i].second][j] = false;
				else
					places[params[i].second][j] = true;
			}
		}
		cout<<"YES\n";
		vector<char> used(n/2,false);
		for(int i = 0;i<n/2;i++)
		{
			for(int j = n/2;j<n;j++)
			{
				if(!used[j-n/2])
				{
					if(good(places,i,j))
					{
						cout<<i+1<<" "<<j+1<<endl;
						used[j-n/2] = true;
					}
				}
			}
		}
	}
    return 0;
}